rem
rem  register address         value
rem  -------- -------  --------------------
rem     r0      18h    fraction of seconds
rem     r1      19h    second
rem     r2      1Ah    BCD (binary coded decimal) minute
rem     r3      1Bh    BCD hour
rem     r4      1Ch    BCD day of week
rem     r5      1Dh    BCD date
rem     r6      1Eh    BCD month
rem     r7      1Fh    BCD year
rem

rem display menu ---------------------------------------
  10 print "======================="
  20 print "Menu"
  30 print "0. Set time"
  40 print "1. Get time"
  50 print "2. Quit"
  60 input i
  70 on i goto 80, 460, 700

rem ----------------------------------------------------
rem --- set time ---------------------------------------
rem ----------------------------------------------------

rem set fraction of seconds to 0 -----------------------
  80 DBY(18h)=0

rem ask for the second ---------------------------------
  90 p. "input second"
 100 input i
rem aconvert to BCD
 110 gosub 600
 120 DBY(19h)=j
 130 ph0. i, j

rem ask for the minute ---------------------------------
 140 p. "input minute"
 150 input i
rem aconvert to BCD
 160 gosub 600
 170 DBY(1Ah)=j
 180 ph0. i, j

rem ask for the hour -----------------------------------
 190 p. "input hour"
 200 input i
rem aconvert to BCD
 210 gosub 600
 220 DBY(1Bh)=j
 230 ph0. i, j

rem ask for the day ------------------------------------
 240 p. "input day of week (1 to 7)"
 250 input i
 260 DBY(1Ch)=i
 270 ph0. i

rem ask for the date -----------------------------------
 280 p. "input day of the month"
 290 input i
rem aconvert to BCD
 300 gosub 600
 310 DBY(1Dh)=j
 320 ph0. i, j

rem ask for the month ----------------------------------
 330 p. "input month (1 to 12)"
 340 input i
rem aconvert to BCD
 350 gosub 600
 360 DBY(1Eh)=j
 370 ph0. i, j

rem ask for the year -----------------------------------
 380 p. "input year (two digits, e.g. 94)"
 390 input i
rem aconvert to BCD
 400 gosub 600
 410 DBY(1Fh)=j
 420 ph0. i, j

rem call the BputTime routine in EPROM -----------------
 430 call 0c014h
 440 p. "time stored"
 450 goto 10

rem ----------------------------------------------------
rem --- get time ---------------------------------------
rem ----------------------------------------------------
rem endless loop - press control C to quit -------------
 460 call 0c016h

 470 ph0. "    fraction : ", DBY(18h)
 480 ph0. "      second : ", DBY(19h)
 490 ph0. "      minute : ", DBY(1Ah)
 500 ph0. "        hour : ", DBY(1Bh)
 510 ph0. " day of week : ", DBY(1Ch)
 520 ph0. "day of month : ", DBY(1Dh)
 530 ph0. "       month : ", DBY(1Eh)
 540 ph0. "        year : ", DBY(1Fh)
 550 goto 10


rem  --- DEC to BCD converter ---
 600 j=16*int(i/10) + i-10*int(i/10)
 610 return

 700 stop
 710 end

